function max_abs_approx_error = residual_cheb(beta,chi,epsilon,alpha,mu,k,nd,dmin,dmax,cv,cn,cd,Gamma0,p01)
%
%Willem Van Zandweghe and Alexander L. Wolman

%DEFINE APPROXIMATION SPACE
fspace = fundefn('cheb',nd,dmin,dmax);
dgrid = funnode(fspace);

%COMPUTE dres BY ADDING k/nd EVENLY SPREAD NODES BETWEEN (BUT NOT ON) EACH NODE ON dgrid
dres = zeros(k,1);
delta = (dgrid(2)-dgrid(1))/(k/nd);
dres(1:k/nd) = (dgrid(1)+0.5*delta:delta:dgrid(2)-0.5*delta)';
for i = 2:nd
delta = (dgrid(i)-dgrid(i-1))/(k/nd);
dres(1+(i-1)*(k/nd):i*k/nd) = (dgrid(i-1)+0.5*delta:delta:dgrid(i)-0.5*delta)';
end

%COMPUTE RESIDUAL OF VALUE FUNCTION
% bigNres = funeval(cn,fspace,dres);
% bigDres = funeval(cd,fspace,dres);
% p0res = (epsilon/(epsilon-1))*bigNres./bigDres;
p0res = interp1(dgrid,p01,dres);
inflationres=inflation(p0res,alpha,epsilon);
Gammares=interp1(dgrid,Gamma0,dres);
cres = Gammares./inflationres;
dprimeres = dprime(p0res,dres,alpha,epsilon);
nres = cres.*dprimeres;
ures = log(cres) - (chi/(1+mu))*nres.^(1+mu);
vprimeres = funeval(cv,fspace,dprimeres);
vres = funeval(cv,fspace,dres);
resv = vres - ures - beta*vprimeres;

max_abs_approx_error = max(abs(resv));
