function [dss,piss,p0ss] = steadystate_cheb(dmin,dmax,nd,p00,alpha,epsilon)
%function dss uses interpolation to compute the fixed point where dgrid=dprimegrid
%Linear interpolation y = y0+(x-x0)*(y1-y0)/(x1-x0) with x=y
fspace = fundefn('cheb',nd,dmin,dmax);
dgrid = funnode(fspace);
markup = epsilon/(epsilon-1);
dprimegrid = dprime(p00,dgrid,alpha,epsilon);
%Compute fixed point of the state
dss=-99;
for i=1:(nd-1)
if (dgrid(i)<dprimegrid(i)) && (dgrid(i+1)>dprimegrid(i+1))
    dss = (dprimegrid(i)*dgrid(i+1) - dgrid(i)*dprimegrid(i+1))/(dgrid(i+1)-dgrid(i)-dprimegrid(i+1)+dprimegrid(i));
end
end
if dss==-99
     error('I cannot compute the steady state. Do you have a corner solution?')
end
p0ss = interp1(dgrid,p00,dss);
piss=inflation(p0ss,alpha,epsilon);

% mss = interp1(dgrid,Gamma0,dss);
% css = mss/piss;
% nss = dss*css;