import numpy as np
from scipy import optimize
from numpy.polynomial.polynomial import polyvander
from numpy.polynomial.polynomial import polyval
import matplotlib.pyplot as plt
import os

os.chdir('your directory here...')

################################################################### Functions
def all_devs(PSI_0, output='sumsq', print_cost=True):
	global Del_prime
	global minCost
	global bestPSI
	global simplex
	m = PSI_0
	p0_opt = optimize.minimize(p0_fn_devs, x0=p0_start, args=(m,), method='Nelder-Mead').x

	p0 = p0_opt
	cnsn = C_big(p0,m)
	labor = N_frak(kgrid,p0,m)
	Dfrak = D_frak(kgrid,p0)   # note: This is Delta_prime
	Del_prime = Dfrak

	Nfn = optimize.minimize(n_fn_devs, x0=N_0, args=(m, p0), method='Nelder-Mead').x
	Dfn = optimize.minimize(d_fn_devs, x0=D_0, args=(p0,), method='Nelder-Mead').x

	################################ Current period derivatives
	d_u_c = du_c(cnsn)
	d_C_m = dC_m(p0)
	d_u_n = du_n(labor)
	d_C_p0 = dC_p0(p0,m)
	d_Nfrak_p0 = dN_frak_p0(kgrid,p0,m)
	d_Nfrak_dlta = dD_frak_dlta(kgrid,p0)
	d_Nfrak_m = dN_frak_m(kgrid,p0,m)
	d_Dfrak_p0 = dD_frak_p0(kgrid,p0)
	d_Dfrak_dlta = dD_frak_dlta(kgrid,p0)
	#  D function and N function at next period's grid points
	Dfn_prm = ChebyApproxFn(n_approx,Dfn,Dfrak)
	Nfn_prm = ChebyApproxFn(n_approx,Nfn,Dfrak)

	#-------------------------------------------------------
	# Now move on to the derivatives of the eta function,
	# needed for derivatives of H(m,delta)
	#-------------------------------------------------------
	
	# -   -    -    -  -
	# first d_eta/d_m
	# -   -    -    -  -
	d_eta_m = -mkp_* q(p0)**(1/(1-eps_)) * (chi_* labor**mu_*d_C_m + \
                   mu_*chi_*cnsn* labor**(mu_-1)*d_Nfrak_m)
	
	# -   -    -    -  -
	# next d_eta/d_p0
	# -   -    -    -  -

	# Compute Cheb polynomial derivatives
	Cheb_coeffs_n = np.linalg.solve(T_fnjk, Nfn)
	d_Cheb_coeffs_n = np.arange(n_approx,0,-1) * Cheb_coeffs_n[0:n_approx]
	Cheb_coeffs_d = np.linalg.solve(T_fnjk, Dfn)
	d_Cheb_coeffs_d = np.arange(n_approx,0,-1) * Cheb_coeffs_d[0:n_approx]

	Dfrak_V = np.fliplr(polyvander(Dfrak, n_approx-1))
	d_n_prm = np.dot(Dfrak_V, d_Cheb_coeffs_n)
	d_d_prm = np.dot(Dfrak_V, d_Cheb_coeffs_d)

	# corrected next line on 9/10/13
	line1 = 1 + (1-eta_)*beta_*Dfn_prm + p0*(1-eta_)*beta_*d_d_prm*d_Dfrak_p0
	l2f1 = q(p0)**(1/(1-eps_))
	l2f2 = mu_*chi_*cnsn* labor**(mu_-1)*d_Nfrak_p0 + chi_* labor**mu_*d_C_p0 + \
                              (1-eta_)*beta_*d_n_prm*d_Dfrak_p0
	line2 = mkp_*l2f1*l2f2
	l3f1 = chi_*cnsn* labor**mu_ + (1-eta_)*beta_*Nfn_prm
	line3 = mkp_*l3f1*eta_* q(p0)**(-mkp_)* p0**(-eps_)
	d_eta_p0 = line1 - line2 - line3

	# -   -    -    -  -
	# and now d_eta/d_delta
	# -   -    -    -  -
	term1 = p0*(1-eta_)*beta_*d_d_prm*d_Dfrak_dlta
	term2 =  mkp_* q(p0)**(1/(1-eps_))*(mu_*chi_*cnsn* labor**(mu_-1)*d_Nfrak_dlta + \
                  (1-eta_)*beta_*d_n_prm*d_Dfrak_dlta)
	d_eta_dlta = term1 - term2
	
	# using derivatives of eta function, get derivatives of H function
	d_H_m = -d_eta_m/d_eta_p0
	d_H_dlta = -d_eta_dlta/d_eta_p0


	################################ Next period derivatives
	# basic variables
	p0_prm = ChebyApproxFn(n_approx,p0,Dfrak)
	m_prm = ChebyApproxFn(n_approx,m,Dfrak)
	cnsn_prm = C_big(p0_prm,m_prm)
	labor_prm = N_frak(Dfrak,p0_prm,m_prm)
	Dfrak_prm = D_frak(Dfrak,p0_prm)
	d_u_c_prm = du_c(cnsn_prm)
	d_C_m_prm = dC_m(p0_prm)
	d_u_n_prm = du_n(labor_prm)
	d_C_p0_prm =  dC_p0(p0_prm,m_prm)
	d_Nfrak_p0_prm = dN_frak_p0(Dfrak,p0_prm,m_prm)
	d_Nfrak_dlta_prm = dN_frak_dlta(Dfrak,p0_prm,m_prm)
	d_Nfrak_m_prm = dN_frak_m(Dfrak,p0_prm,m_prm)
	d_Dfrak_p0_prm = dD_frak_p0(Dfrak,p0_prm)
	d_Dfrak_dlta_prm = dD_frak_dlta(Dfrak,p0_prm)
	#  D function and N function at two period ahead's grid points
	Dfn_prm2 = ChebyApproxFn(n_approx,Dfn,Dfrak_prm)
	Nfn_prm2 = ChebyApproxFn(n_approx,Nfn,Dfrak_prm)

	#-------------------------------------------------------
	# Now move on to the derivatives of next period's eta function,
	# needed for derivatives of next period's H(m,delta)
	#-------------------------------------------------------

	# -   -    -    -  -
	# first d_eta/d_m
	# -   -    -    -  -
	fac1_prm = eta_* p0_prm**(1-eps_) + 1-eta_
	fac2_prm = chi_* labor_prm**mu_ *d_C_m_prm + mu_*chi_*cnsn_prm* \
                labor_prm**(mu_-1)*d_Nfrak_m_prm
	d_eta_m_prm = -mkp_* fac1_prm**(1/(1-eps_)) * fac2_prm

	# -   -    -    -  -
	# next d_eta/d_p0
	# -   -    -    -  -
	Dfrak_prm_V = np.fliplr(polyvander(Dfrak_prm, n_approx-1))
	d_n_prm2 = np.dot(Dfrak_prm_V, d_Cheb_coeffs_n)
	d_d_prm2 = np.dot(Dfrak_prm_V, d_Cheb_coeffs_d)

	# corrected next line on Sep 10, 2013
	line1_prm = 1 + (1-eta_)*beta_*Dfn_prm2 + p0_prm*(1-eta_)*beta_*d_d_prm2* \
                 d_Dfrak_p0_prm
	l2f1_prm = fac1_prm**(1/(1-eps_))
	l2f2_prm = mu_*chi_*cnsn_prm* labor_prm**(mu_-1)*d_Nfrak_p0_prm + \
                  chi_* labor_prm**mu_*d_C_p0_prm + (1-eta_)*beta_*d_n_prm2* \
                  d_Dfrak_p0_prm
	line2_prm = mkp_*l2f1_prm*l2f2_prm
	l3f1_prm = chi_*cnsn_prm* labor_prm**mu_ + (1-eta_)*beta_*Nfn_prm2
	line3_prm = mkp_*l3f1_prm*eta_* fac1_prm**(-mkp_)* p0_prm**(-eps_)
	d_eta_p0_prm = line1_prm - line2_prm - line3_prm

	# -   -    -    -  -
	# and now d_eta/d_delta
	# -   -    -    -  -
	term1_prm = p0_prm*(1-eta_)*beta_*d_d_prm2*d_Dfrak_dlta_prm
	term2_prm =  mkp_* fac1_prm**(1/(1-eps_)) * (mu_*chi_*cnsn_prm* labor_prm**(mu_-1)* \
                    d_Nfrak_dlta_prm + (1-eta_)*beta_*d_n_prm2*d_Dfrak_dlta_prm)
	d_eta_dlta_prm = term1_prm - term2_prm

	# using derivatives of eta function, get derivatives of H function
	d_H_m_prm = -d_eta_m_prm/d_eta_p0_prm
	d_H_d_prm = -d_eta_dlta_prm/d_eta_p0_prm


	# Construct GEE deviations
	captheta = (d_u_c*d_C_m + d_u_n*d_Nfrak_m + d_H_m*(d_u_c*d_C_p0 + \
                                      d_u_n*d_Nfrak_p0)) / (d_Dfrak_p0*d_H_m)
	captheta_prm = ((1-zap_dyn)*(d_u_c_prm*d_C_m_prm + d_u_n_prm*d_Nfrak_m_prm) +
		d_H_m_prm*(d_u_c_prm*d_C_p0_prm + d_u_n_prm*d_Nfrak_p0_prm)) / \
                 (d_Dfrak_p0_prm*d_H_m_prm)

	bigfac1 = d_u_n_prm*d_Nfrak_dlta_prm
	bigfac2 = (d_u_c_prm*d_C_m_prm + d_u_n_prm*d_Nfrak_m_prm) / d_H_m_prm
	bigfactor = bigfac1 - (1-zap_dyn)*d_H_d_prm*bigfac2
	gee_devs = captheta - beta_*d_Dfrak_dlta_prm*captheta_prm + beta_*bigfactor
	
	cost = sum(gee_devs**2)
	if cost < minCost:
		minCost = cost
		bestPSI = PSI_0
	
	if print_cost:
		print('Cost function: ' + '%.9f'%cost + '\tRunning min: ' + '%.9f'%minCost)
	if output == 'sumsq':
		return cost
	elif output == 'devs':
		return gee_devs


def p0_fn_devs(p0, m):
	# track the changing Chebyshev coefficients for given p0,m
	#global N_coefs; N_coefs = []
	#global D_coefs; D_coefs = []
	n_fn = optimize.minimize(n_fn_devs, x0=N_0, args=(m, p0), method='Nelder-Mead').x
	d_fn = optimize.minimize(d_fn_devs, x0=D_0, args=(p0,), method='Nelder-Mead').x
	p0_devs = p0 - mkp_ * n_fn / d_fn
	return sum(p0_devs**2)

def d_fn_devs(D, p0):
	a = 1 / q(p0)
	b = (1-eta_)*beta_ / q(p0)
	del_prm = D_frak(kgrid, p0)
	d_devs = D - (a + b*update_d_fn(D,del_prm))
	# print "d_devs: ", sum(d_devs**2)
	return sum(d_devs**2)

def n_fn_devs(N, m, p0):
	a = chi_* C_big(p0,m) * N_frak(kgrid,p0,m)**mu_ / q(p0)**mkp_
	b = (1-eta_)*beta_ / q(p0)**mkp_
	del_prm = D_frak(kgrid, p0)
	n_devs = N - (a + b*update_n_fn(N,del_prm))
	#print "n_devs: ", sum(n_devs**2)
	return sum(n_devs**2)

def N_frak(dlta, p0, m):
	return (eta_* p0**(-eps_) + (1-eta_)*dlta) / q(p0)

def dN_frak_p0(dlta, p0, m):
	f1num = -eta_*m* p0**(-eps_-1)
	f1den = q(p0)**2
	f2 = eta_* p0**(1-eps_) + (1-eta_)*(eps_ + (1-eps_)*p0*dlta)
	return f2 * f1num/f1den

def dN_frak_m(dlta, p0, m):
	return (eta_* p0**(-eps_) + (1-eta_)*dlta) / q(p0)

def dN_frak_dlta(dlta, p0, m):
	return (1-eta_)*m / q(p0)

def D_frak(dlta, p0):
	x = eta_* p0**(-eps_) + (1-eta_)*dlta
	y = q(p0)**(-mkp_)
	return x*y

def dD_frak_p0(dlta, p0):
	f1 = -eps_* eta_* p0**(-eps_-1)* q(p0)**(-mkp_)
	f2 = eta_* p0**(-eps_) + (1-eta_)*dlta
	return f1*(1 - p0*f2/q(p0))

def dD_frak_dlta(dlta, p0):
	return (1-eta_)*(eta_* p0**(1-eps_) + 1-eta_)**(-mkp_)

def update_d_fn(d_old,del_prime):
	coefs = np.linalg.solve(T_fnjk, d_old)
	#D_coefs.append(coefs)
	return polyval(del_prime, np.flipud(coefs))
	#return ChebyApproxFn(n_approx,d_old,del_prime)

def update_n_fn(n_old,del_prime):
	coefs = np.linalg.solve(T_fnjk, n_old)
	#N_coefs.append(coefs)
	return polyval(del_prime, np.flipud(coefs))
	#return ChebyApproxFn(n_approx,n_old,del_prime)

def ChebyApproxFn(n, yvec, xnew):
	# Note: http://stackoverflow.com/questions/31256252/why-does-numpy-linalg-solve-offer-more-precise-matrix-inversions-than-numpy-li
	# coefs = np.dot(T_mat, yvec)
	coefs = np.linalg.solve(T_fnjk, yvec)
	return polyval(xnew, np.flipud(coefs))

# Consumption function and derivatives
def C_big(p0,m): return m* q(p0)**(1/(eps_-1))
def dC_m(p0): return q(p0)**(1/(eps_-1))
def dC_p0(p0,m): return -eta_*m* p0**(-eps_)* q(p0)**((2-eps_)/(eps_-1))

# Utility function & derivatives (c: consumption, n: labor)
def u_fn(c,n): return np.log(c) - chi_/(1+mu_)* n**(1+mu_)
def du_c(c): return 1./c
def du_n(n): return -chi_* n**mu_

def q(p0): return eta_* p0**(1-eps_) + 1-eta_


################################################################### Parameters
beta_ = 0.99
eta_ = 0.5
eps_ = 10.
mu_ = 0.
chi_ = 4.5
mkp_ = eps_/(eps_-1) # Markup
# this zap_dyn should always be zero
zap_dyn = 0.

# Initial values for optimization
PSI_0 = np.linspace(.2006, .2026, 3)
N_0 = np.array([2.34092986197413, 2.29636041074918, 2.25134346991978])
D_0 = np.array([2.53024884726165, 2.4895224501598, 2.44818875866431])
p0_start = mkp_ * N_0 / D_0


################################################################### Main

# use Willem dgrid (middle 3 points)
kgrid = np.array([1.00206107373854, 1.005, 1.00793892626146])

n_approx = len(kgrid) - 1

# Reverse Vandermonde matrix as in (3.5) on pg 44 of
# http://www-solar.mcs.st-andrews.ac.uk/~clare/Lectures/num-analysis/Numan_chap3.pdf
T_fnjk = np.fliplr( polyvander(kgrid, n_approx))

# Keep track of running min of cost function (later: try to add early stopping)
minCost = float('inf')
theta_opt = optimize.minimize(all_devs, x0=PSI_0, method='Nelder-Mead',
	options={'disp':True, 'maxfev':2500, 'fatol':1e-8, 'return_all':True})

# Compute devs at each iteration (no way to store this from above??)
devs = np.array([all_devs(v, print_cost=False) for v in theta_opt.allvecs])
devs = devs.reshape(theta_opt.nit, 1)

res = np.hstack([np.vstack(theta_opt.allvecs), devs, np.log10(devs)])

#np.savetxt('NelderMead_res.csv', res, delimiter=',')

# Cost function
plt.step(np.arange(theta_opt.nit), np.log10(devs), where='post')
plt.ylabel(r'log$_{10}$(devs)'); plt.xlabel('iter')
plt.show()

plt.plot(kgrid, kgrid, 'b--')
plt.plot(kgrid, Del_prime, 'r')
plt.gca().get_xaxis().get_major_formatter().set_useOffset(False)
plt.gca().get_yaxis().get_major_formatter().set_useOffset(False)
plt.xlabel('k')
plt.show()

# compute intersection (k_ss)
slope = (Del_prime[1] - Del_prime[0]) / (kgrid[1] - kgrid[0])
k_ss = (Del_prime[0] - slope*kgrid[0]) / (1 - slope)

# compute steady-state inflation
def k_ss_devs(pi_ss):
	term1 = (eta_*pi_ss**eps_) / (1 - (1-eta_)*pi_ss**eps_)
	term2 = ((pi_ss**(1-eps_) - (1-eta_)) / eta_)**mkp_
	return (k_ss - term1*term2)**2

pi_ss = optimize.minimize(k_ss_devs, x0=1.01).x




